diff --git a/arch/arm/dts/exynos4210-origen.dts b/arch/arm/dts/exynos4210-origen.dts
index a4915de2c49c..40289c8c4aaf 100644
--- a/arch/arm/dts/exynos4210-origen.dts
+++ b/arch/arm/dts/exynos4210-origen.dts
@@ -25,9 +25,7 @@
 };
 
 &sdhci2 {
-	samsung,bus-width = <4>;
 	bus-width = <4>;
-	samsung,timing = <1 2 3>;
 	cd-gpios = <&gpk2 2 0>;
 	status = "okay";
 };
diff --git a/arch/arm/dts/exynos4210-trats.dts b/arch/arm/dts/exynos4210-trats.dts
index 4fbdf4730994..88e9c0ed2bb0 100644
--- a/arch/arm/dts/exynos4210-trats.dts
+++ b/arch/arm/dts/exynos4210-trats.dts
@@ -240,17 +240,13 @@
 };
 
 &sdhci0 {
-	samsung,bus-width = <8>;
 	bus-width = <8>;
-	samsung,timing = <1 3 3>;
 	pwr-gpios = <&gpk0 2 0>;
 	status = "okay";
 };
 
 &sdhci2 {
-	samsung,bus-width = <4>;
 	bus-width = <4>;
-	samsung,timing = <1 2 3>;
 	cd-gpios = <&gpx3 4 0>;
 	status = "okay";
 };
diff --git a/arch/arm/dts/exynos4210-universal_c210.dts b/arch/arm/dts/exynos4210-universal_c210.dts
index 1b3ac1fee15f..c87b92be609d 100644
--- a/arch/arm/dts/exynos4210-universal_c210.dts
+++ b/arch/arm/dts/exynos4210-universal_c210.dts
@@ -235,17 +235,13 @@
 };
 
 &sdhci0 {
-	samsung,bus-width = <8>;
 	bus-width = <8>;
-	samsung,timing = <1 3 3>;
 	pwr-gpios = <&gpk0 2 0>;
 	status = "okay";
 };
 
 &sdhci2 {
-	samsung,bus-width = <4>;
 	bus-width = <4>;
-	samsung,timing = <1 2 3>;
 	cd-gpios = <&gpx3 4 0>;
 	status = "okay";
 };
diff --git a/arch/arm/dts/exynos4412-odroid.dts b/arch/arm/dts/exynos4412-odroid.dts
index a405b9708719..346e0f55c768 100644
--- a/arch/arm/dts/exynos4412-odroid.dts
+++ b/arch/arm/dts/exynos4412-odroid.dts
@@ -234,27 +234,19 @@
 };
 
 &sdhci2 {
-	samsung,bus-width = <4>;
 	bus-width = <4>;
-	samsung,timing = <1 2 3>;
 	cd-inverted;
 	cd-gpios = <&gpk2 2 0>;
 	status = "okay";
 };
 
 &mshc_0 {
-	samsung,bus-width = <8>;
 	bus-width = <8>;
-	samsung,timing = <2 1 0>;
 	samsung,dw-mshc-ciu-div = <0>;
 	samsung,dw-mshc-sdr-timing = <2 1>;
-	samsung,removable = <0>;
 	non-removable;
-	fifoth_val = <0x203f0040>;
 	fifo-depth = <0x80>;
 	clock-frequency = <400000000>;
-	bus_hz = <400000000>;
-	div = <0x3>;
 	index = <4>;
 	status = "okay";
 };
diff --git a/arch/arm/dts/exynos4412-trats2.dts b/arch/arm/dts/exynos4412-trats2.dts
index 30758ffa1ef9..2b71d328cd0e 100644
--- a/arch/arm/dts/exynos4412-trats2.dts
+++ b/arch/arm/dts/exynos4412-trats2.dts
@@ -108,9 +108,7 @@
 	};
 
 	sdhci@12510000 {
-		samsung,bus-width = <8>;
 		bus-width = <8>;
-		samsung,timing = <1 3 3>;
 		pwr-gpios = <&gpk0 4 0>;
 		status = "disabled";
 	};
@@ -432,33 +430,23 @@
 };
 
 &sdhci0 {
-	samsung,bus-width = <8>;
 	bus-width = <8>;
-	samsung,timing = <1 3 3>;
 	pwr-gpios = <&gpk0 4 0>;
 	status = "disabled";
 };
 
 &sdhci2 {
-	samsung,bus-width = <4>;
 	bus-width = <4>;
-	samsung,timing = <1 2 3>;
 	cd-gpios = <&gpk2 2 0>;
 	status = "okay";
 };
 
 &mshc_0 {
-	samsung,bus-width = <8>;
 	bus-width = <8>;
-	samsung,timing = <2 1 0>;
 	samsung,dw-mshc-ciu-div = <0>;
 	samsung,dw-mshc-sdr-timing = <2 1>;
-	samsung,removable = <0>;
 	non-removable;
-	fifoth_val = <0x203f0040>;
 	clock-frequency = <400000000>;
-	bus_hz = <400000000>;
-	div = <0x3>;
 	index = <4>;
 	fifo-depth = <0x80>;
 	status = "okay";
diff --git a/arch/arm/dts/exynos5250-arndale.dts b/arch/arm/dts/exynos5250-arndale.dts
index 7f84589c97a2..4c894f1712fa 100644
--- a/arch/arm/dts/exynos5250-arndale.dts
+++ b/arch/arm/dts/exynos5250-arndale.dts
@@ -27,9 +27,7 @@
 	};
 
 	mmc@12200000 {
-		samsung,bus-width = <8>;
 		bus-width = <8>;
-		samsung,timing = <1 3 3>;
 		samsung,dw-mshc-ciu-div = <3>;
 		samsung,dw-mshc-sdr-timing = <1 3>;
 	};
@@ -39,9 +37,7 @@
 	};
 
 	mmc@12220000 {
-		samsung,bus-width = <4>;
 		bus-width = <4>;
-		samsung,timing = <1 2 3>;
 		samsung,dw-mshc-ciu-div = <3>;
 		samsung,dw-mshc-sdr-timing = <1 2>;
 	};
diff --git a/arch/arm/dts/exynos5250-smdk5250.dts b/arch/arm/dts/exynos5250-smdk5250.dts
index 882db2d1f608..f9f54cb63871 100644
--- a/arch/arm/dts/exynos5250-smdk5250.dts
+++ b/arch/arm/dts/exynos5250-smdk5250.dts
@@ -145,12 +145,9 @@
 	};
 
 	mmc@12200000 {
-		samsung,bus-width = <8>;
 		bus-width = <8>;
-		samsung,timing = <1 3 3>;
 		samsung,dw-mshc-ciu-div = <3>;
 		samsung,dw-mshc-sdr-timing = <1 3>;
-		samsung,removable = <0>;
 		non-removable;
 	};
 
@@ -159,12 +156,9 @@
 	};
 
 	mmc@12220000 {
-		samsung,bus-width = <4>;
 		bus-width = <4>;
-		samsung,timing = <1 2 3>;
 		samsung,dw-mshc-ciu-div = <3>;
 		samsung,dw-mshc-sdr-timing = <1 2>;
-		samsung,removable = <1>;
 	};
 
 	mmc@12230000 {
diff --git a/arch/arm/dts/exynos5250-snow.dts b/arch/arm/dts/exynos5250-snow.dts
index bcf04d5c07c0..ab7b5212ba7c 100644
--- a/arch/arm/dts/exynos5250-snow.dts
+++ b/arch/arm/dts/exynos5250-snow.dts
@@ -301,12 +301,9 @@
 	};
 
 	mmc@12200000 {
-		samsung,bus-width = <8>;
 		bus-width = <8>;
-		samsung,timing = <1 3 3>;
 		samsung,dw-mshc-ciu-div = <3>;
 		samsung,dw-mshc-sdr-timing = <1 3>;
-		samsung,removable = <0>;
 		non-removable;
 	};
 
@@ -315,12 +312,9 @@
 	};
 
 	mmc@12220000 {
-		samsung,bus-width = <4>;
 		bus-width = <4>;
-		samsung,timing = <1 2 3>;
 		samsung,dw-mshc-ciu-div = <3>;
 		samsung,dw-mshc-sdr-timing = <1 2>;
-		samsung,removable = <1>;
 	};
 
 	mmc@12230000 {
diff --git a/arch/arm/dts/exynos5250-spring.dts b/arch/arm/dts/exynos5250-spring.dts
index 7270a546a795..9c478837ba44 100644
--- a/arch/arm/dts/exynos5250-spring.dts
+++ b/arch/arm/dts/exynos5250-spring.dts
@@ -103,12 +103,9 @@
 	};
 
 	mmc@12200000 {
-		samsung,bus-width = <8>;
 		bus-width = <8>;
-		samsung,timing = <1 3 3>;
 		samsung,dw-mshc-ciu-div = <3>;
 		samsung,dw-mshc-sdr-timing = <1 3>;
-		samsung,removable = <0>;
 		non-removable;
 	};
 
diff --git a/arch/arm/dts/exynos5420-smdk5420.dts b/arch/arm/dts/exynos5420-smdk5420.dts
index 1f27baafebaf..6ba1306e862a 100644
--- a/arch/arm/dts/exynos5420-smdk5420.dts
+++ b/arch/arm/dts/exynos5420-smdk5420.dts
@@ -106,12 +106,9 @@
 	};
 
 	mmc@12200000 {
-		samsung,bus-width = <8>;
 		bus-width = <8>;
-		samsung,timing = <1 3 3>;
 		samsung,dw-mshc-ciu-div = <3>;
 		samsung,dw-mshc-sdr-timing = <1 3>;
-		samsung,removable = <0>;
 		non-removable;
 		samsung,pre-init;
 	};
@@ -121,12 +118,9 @@
 	};
 
 	mmc@12220000 {
-		samsung,bus-width = <4>;
 		bus-width = <4>;
-		samsung,timing = <1 2 3>;
 		samsung,dw-mshc-ciu-div = <3>;
 		samsung,dw-mshc-sdr-timing = <1 2>;
-		samsung,removable = <1>;
 	};
 
 	mmc@12230000 {
diff --git a/arch/arm/dts/exynos5422-odroidxu3.dts b/arch/arm/dts/exynos5422-odroidxu3.dts
index 767b3e415d58..ef25cf774470 100644
--- a/arch/arm/dts/exynos5422-odroidxu3.dts
+++ b/arch/arm/dts/exynos5422-odroidxu3.dts
@@ -280,12 +280,10 @@
 	};
 
 	mmc@12200000 {
-		fifoth_val = <0x201f0020>;
 		fifo-depth = <0x40>;
 	};
 
 	mmc@12220000 {
-		fifoth_val = <0x201f0020>;
 		fifo-depth = <0x40>;
 	};
 
diff --git a/arch/arm/dts/exynos54xx.dtsi b/arch/arm/dts/exynos54xx.dtsi
index fd74166c7e48..5915ed697791 100644
--- a/arch/arm/dts/exynos54xx.dtsi
+++ b/arch/arm/dts/exynos54xx.dtsi
@@ -119,12 +119,9 @@
 	};
 
 	mmc@12200000 {
-		samsung,bus-width = <8>;
 		bus-width = <8>;
-		samsung,timing = <1 3 3>;
 		samsung,dw-mshc-ciu-div = <3>;
 		samsung,dw-mshc-sdr-timing = <1 3>;
-		samsung,removable = <0>;
 		non-removable;
 		samsung,pre-init;
 	};
@@ -134,12 +131,9 @@
 	};
 
 	mmc@12220000 {
-		samsung,bus-width = <4>;
 		bus-width = <4>;
-		samsung,timing = <1 2 3>;
 		samsung,dw-mshc-ciu-div = <3>;
 		samsung,dw-mshc-sdr-timing = <1 2>;
-		samsung,removable = <1>;
 	};
 
 	mmc@12230000 {